﻿using Sharpex2D;
using Sharpex2D.Framework.Game;
using Sharpex2D.Framework.Game.Services;
using Sharpex2D.Framework.Media;
using Sharpex2D.Framework.Rendering;
using Sharpex2D.Framework.Rendering.Devices;

namespace MyGame
{
    public class MainGame : Game
    {

        public override void OnUpdate(GameTime gameTime)
        {
            _piggyPlayer.Update(gameTime);
        }

        public override void OnRendering(Sharpex2D.Framework.Rendering.Devices.RenderDevice renderer, GameTime gameTime)
        {
            renderer.Begin();
            _piggyPlayer.Render(renderer, gameTime);
            renderer.End();
        }

        private PiggyPlayer _piggyPlayer;

        public override EngineConfiguration OnInitialize(LaunchParameters launchParameters)
        {
            RenderDevice resultDevice = DeviceSelector.Select(
                new RenderDevice[]
                {
                    new Sharpex2D.Framework.Rendering.DirectX9.DirectXRenderDevice(),
                    new Sharpex2D.Framework.Rendering.DirectX10.DirectXRenderDevice(),
                    new Sharpex2D.Framework.Rendering.DirectX11.DirectXRenderDevice()
                }, DeviceSelector.SelectorMode.Lowest);

            MediaInitializer mediaInitializer = MediaInitializer.Empty;

            return new EngineConfiguration(resultDevice, mediaInitializer);
        }

        public override void OnLoadContent()
        {
            _piggyPlayer = new PiggyPlayer();
            _piggyPlayer.Texture = Content.Load<Texture2D>("pig.png");
        }
    }
}
